<?php

/**
 * webEdition CMS
 *
 * $Rev: 9df9d90b2be7 $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2019-12-17 15:43 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
return
		[
			'administrator' => [
				'title' => g_l('perms_administrator', '[perm_group_title]'),
				'defaults' => [
					we_base_perm::ADMINISTRATOR => 0
				],
			],
			we_modules_info::BANNER => [
				'title' => g_l('perms_banner', '[perm_group_title]'),
				'defaults' => (we_modules_info::isActive(we_modules_info::BANNER) ? [
			we_base_perm::BANNER_NEW => 1,
			we_base_perm::BANNER_DELETE => 0,
			we_base_perm::BANNER_EDIT => 0
				] : [])
			],
			we_modules_info::USERS => [
				'title' => g_l('menu_moduleInformation', '[users][text]'),
				'defaults' => [/*
				  we_base_perm::USER_GROUP_NEW => 0,
				  we_base_perm::USER_NEW => 0,
				  we_base_perm::USER_GROUP_SAVE => 0,
				  we_base_perm::USER_SAVE => 0,
				  we_base_perm::USER_GROUP_DELETE => 0,
				  we_base_perm::USER_DELETE => 0, */
				]
			],
			'controlpermissions' => [
				'title' => g_l('perms_controlpermissions', '[perm_group_title]'),
				'defaults' => [
					we_base_perm::WORK_DOCUMENT_SAVE_ALLOWED => 1,
					we_base_perm::WORK_CAN_PUBLISH => 1,
					we_base_perm::USER_CHANGE_DOCUMENT_OWNER => 0,
					we_base_perm::USER_CHANGE_DOCUMENT_PERMISSION => 0,
				]
			],
			'widget' => [
				'title' => g_l('perms_widget', '[perm_group_title]'),
				'defaults' => [
					we_base_perm::WIDGET_EDIT_MFD => 0,
					we_base_perm::WIDGET_SHOW_USR => 1
				]
			],
			we_modules_info::CUSTOMER => [
				'title' => g_l('perms_customer', '[perm_group_title]'),
				'defaults' => (we_modules_info::isActive(we_modules_info::CUSTOMER) ? [
			we_base_perm::CUSTOMER_NEW => 0,
			we_base_perm::CUSTOMER_DELETE => 0,
			we_base_perm::CUSTOMER_EDIT => 0,
			we_base_perm::CUSTOMER__SHOW_ADMIN => 0,
			we_base_perm::CUSTOMER_AUTOLOGINID_VISIBLE => 0,
			we_base_perm::CUSTOMER_CAN_EDIT_CUSTOMERFILTER => 1,
			we_base_perm::CUSTOMER_CAN_CHANGE_DOCS => 1,
			we_base_perm::CUSTOMER_DECRYPT_FIELD => 1,
			we_base_perm::CUSTOMER_CHANGE_ENCRYPTED_FIELD => 1,
				] : [])
			],
			we_modules_info::GLOSSARY => [
				'title' => g_l('perms_glossary', '[perm_group_title]'),
				'defaults' => (we_modules_info::isActive(we_modules_info::GLOSSARY) ? [
			we_base_perm::GLOSSARY_NEW => 1,
			we_base_perm::GLOSSARY_EDIT => 1,
			we_base_perm::GLOSSARY_DELETE => 1,
			we_base_perm::GLOSSARY_EDIT_DICTIONARY => 1,
				] : [] )
			],
			'importExportpermissions' => [
				'title' => g_l('perms_importExportpermissions', '[perm_group_title]'),
				'defaults' => [
					we_base_perm::EXIM_EXPORT => 0,
					we_base_perm::EXIM_EXPORTNODOWNLOAD => 0,
					we_base_perm::EXIM_IMPORT => 0,
					we_base_perm::EXIM_BACKUPLOG => 0,
					we_base_perm::EXIM_IMPORT_FILE => 1,
					we_base_perm::EXIM_IMPORT_SITE => 1,
					we_base_perm::EXIM_IMPORT_WXML => 0,
					we_base_perm::EXIM_IMPORT_GENERICXML => 0,
					we_base_perm::EXIM_IMPORT_CSV => 0,
					we_base_perm::EXIM_EXPORT_NEW => 0,
					we_base_perm::EXIM_EXPORT_DELETE => 0,
					we_base_perm::EXIM_EXPORT_EDIT => 0,
					we_base_perm::EXIM_EXPORT_MAKE => 0,
					we_base_perm::EXIM_EXPORT_GENERICXML => 1,
					we_base_perm::EXIM_EXPORT_CSV => 1
				]
			],
			we_modules_info::NAVIGATION => [
				'title' => g_l('perms_navigation', '[perm_group_title]'),
				'defaults' => [
					we_base_perm::NAVIGATION_EDIT => 1,
					we_base_perm::NAVIGATION_DELETE => 1,
					we_base_perm::NAVIAGTION_EDIT_RULES => 0,
					we_base_perm::NAVIGATION_EDIT_DYNAMIC => 0,
				]
			],
			we_modules_info::NEWSLETTER => [
				'title' => g_l('perms_newsletter', '[perm_group_title]'),
				'defaults' => (we_modules_info::isActive(we_modules_info::NEWSLETTER) ? [
			we_base_perm::NEWSLETTER_NEW => 0,
			we_base_perm::NEWSLETTER_DELETE => 0,
			we_base_perm::NEWSLETTER_EDIT => 0,
			we_base_perm::NEWSLETTER_SEND => 0,
			we_base_perm::NEWSLETTER_SEND_TEST_EMAIL => 0,
			we_base_perm::NEWSLETTER_SETTINGS => 0,
			we_base_perm::NEWSLETTER_FILES => 0
				] : [])
			],
			we_modules_info::OBJECT => [
				'title' => g_l('perms_object', '[perm_group_title]'),
				'defaults' => (we_modules_info::isActive(we_modules_info::OBJECT) ? [
			we_base_perm::OBJECTFILE_NEW => 1,
			we_base_perm::OBJECT_NEW => 0,
			we_base_perm::OBJECTFILE_NEW_FOLDER => 1,
			we_base_perm::OBJECTFILE_DELETE => 1,
			we_base_perm::OBJECT_DELETE => 0,
			we_base_perm::OBJECTFILE_MOVE => 1,
			we_base_perm::OBJECTS_CAN_SELECT_OTHER_USERS => 1,
			we_base_perm::OBJECTS_CAN_COPY => 1
				] : [])
			],
			'rebuildpermissions' => [
				'title' => g_l('perms_rebuildpermissions', '[perm_group_title]'),
				'defaults' => [
					we_base_perm::REBUILD => 1,
					we_base_perm::REBUILD_ALL => 1,
					we_base_perm::REBUILD_TEMPLATES => 1,
					we_base_perm::REBUILD_FILTERD => 1,
					we_base_perm::REBUILD_OBJECTS => 1,
					we_base_perm::REBUILD_INDEX => 1,
					we_base_perm::REBUILD_THUMBS => 1,
					we_base_perm::REBUILD_NAVIGATION => 1,
					we_base_perm::REBUILD_META => 1
				]
			],
			we_modules_info::SCHEDULER => [
				'title' => g_l('perms_schedule', '[perm_group_title]'),
				'defaults' => (we_modules_info::isActive(we_modules_info::SCHEDULER) ? [
			we_base_perm::SCHEDULER_CAN_SEE => 1
				] : [])
			],
			'GUI' => [
				'title' => g_l('perms_SEEM', '[perm_group_title]'),
				'defaults' => [
					we_base_perm::SEEM_CAN_SEE_MENUE => 1,
					we_base_perm::SEEM_CAN_WORK_NORMAL_MODE => 1,
					we_base_perm::SEEM_CHANGE_START_DOCUMENT => 1,
					we_base_perm::WORK_QUICKSTART_CAN_SEE => 1,
					we_base_perm::WORK_PROPERTIES_CAN_SEE => 1,
					we_base_perm::WORK_INFOTAB_CAN_SEE => 1,
					we_base_perm::WORK_VALIDATION_CAN_SEE => 1,
					we_base_perm::WORK_ACCESSIBLE_PARAMETERS_CAN_SEE => 1,
				]
			],
			'settings' => [
				'title' => g_l('moduleActivation', '[settings]'),
				'defaults' => [
					we_base_perm::USER_EDIT_SETTINGS => 1,
					we_base_perm::USER_EDIT_PASSWD => 1,
					we_base_perm::WORK_DOCTYPE_EDIT => 0,
					we_base_perm::WORK_CATEGORY_EDIT => 1,
					we_base_perm::WORK_FORMMAIL_SHOW => 0,
					we_base_perm::WORK_METADATAFIELD_EDIT => 0,
					we_base_perm::WORK_VALIDATION_EDIT => 0,
					we_base_perm::WORK_BROWSE_SERVER => 0,
				]
			],
			'tree' => [
				'title' => g_l('prefs', '[tree_title]'),
				'defaults' => [
					we_base_perm::WORK_DOCUMENTS_CAN_SEE => 1,
					we_base_perm::WORK_TEMPLATES_CAN_SEE => 0,
					we_base_perm::WORK_COLLECTIONS_CAN_SEE => 1,
					we_base_perm::OBJECTFILES_CAN_SEE => 1,
					we_base_perm::OBJECTS_CAN_SEE => 0,
				]
			],
			we_modules_info::SHOP => [
				'title' => g_l('perms_shop', '[perm_group_title]'),
				'defaults' => (we_modules_info::isActive(we_modules_info::SHOP) ? [
			we_base_perm::SHOP_NEW_ARTICLE => 0,
			we_base_perm::SHOP_DELETE_ARTICLE => 0,
			we_base_perm::SHOP_EDIT_ORDER => 0,
			we_base_perm::SHOP_DELETE_ORDER => 0,
			we_base_perm::SHOP_EDIT_PREFS => 0,
			we_base_perm::VARIANTS_CAN_EDIT => 1
				] : [])
			],
			'versions' => [
				'title' => g_l('perms_versions', '[perm_group_title]'),
				'defaults' => [
					we_base_perm::VERSIONS_CAN_SEE => 0,
					we_base_perm::VERSIONS_RESET => 0
				]
			],
			we_modules_info::VOTING => [
				'title' => g_l('perms_voting', '[perm_group_title]'),
				'defaults' => (we_modules_info::isActive(we_modules_info::VOTING) ? [
			we_base_perm::VOTING_NEW => 1,
			we_base_perm::VOTING_DELETE => 1,
			we_base_perm::VOTING_EDIT => 1
				] : [])
			],
			we_modules_info::WORKFLOW => [
				'title' => g_l('perms_workflow', '[perm_group_title]'),
				'defaults' => (we_modules_info::isActive(we_modules_info::WORKFLOW) ? [
			we_base_perm::WORKFLOW_NEW => 0,
			we_base_perm::WORKFLOW_DELETE => 0,
			we_base_perm::WORKFLOW_EDIT => 0,
			we_base_perm::WORKFLOW_EMPTY_LOG => 0
				] : [])
			],
			'workpermissions' => [
				'title' => g_l('perms_workpermissions', '[perm_group_title]'),
				'defaults' => [
					we_base_perm::WORK_DOCUMENT_WEBEDITION_NEW => 1,
					we_base_perm::WORK_IMAGE_NEW => 1,
					we_base_perm::WORK_HTML_NEW => 1,
					we_base_perm::WORK_VIDEO_NEW => 1,
					we_base_perm::WORK_JS_NEW => 1,
					we_base_perm::WORK_CSS_NEW => 1,
					we_base_perm::WORK_TEXT_NEW => 1,
					we_base_perm::WORK_HTACCESS_NEW => 0,
					we_base_perm::WORK_OTHER_NEW => 1,
					we_base_perm::WORK_TEMPLATE_NEW => 0,
					we_base_perm::WORK_COLLECTION_NEW => 1,
					we_base_perm::WORK_DOCUMENT_FOLDER_NEW => 1,
					we_base_perm::WORK_COLLECTION_FOLDER_NEW => 1,
					we_base_perm::WORK_DOCUMENT_FOLDER_PATH_CHANGE => 0,
					we_base_perm::WORK_TEMPLATES_FOLDER_NEW => 0,
					we_base_perm::WORK_COLLECTION_SAVE => 1,
					we_base_perm::WORK_DOCUMENT_FOLDER_DELETE => 1,
					we_base_perm::WORK_COLLECTION_FOLDER_DELETE => 1,
					we_base_perm::WORK_TEMP_FOLDER_DELETE => 0,
					we_base_perm::WORK_DOCUMENT_DELETE => 1,
					we_base_perm::WORK_TEMPLATE_DELETE => 0,
					we_base_perm::WORK_COLLECTION_DELETE => 1,
					we_base_perm::WORK_DOCUMENT_MOVE => 1,
					we_base_perm::WORK_TEMPLATE_MOVE => 0,
					we_base_perm::WORK_COLLECTION_MOVE => 0,
					we_base_perm::WORK_DOCEXTENSION_EDIT => 0,
					we_base_perm::WORK_WORKSPACE_CAN_SELECT_OTHER_FILES => 1,
					we_base_perm::WORK_EXTERNAL_FILES_CAN_SELECT => 1,
					we_base_perm::WORK_DOCUMENT_NO_DOCTYPE_ALLOWED => 0,
					we_base_perm::WORK_FOLDERS_COPY => 0,
				]
			],
];
