<?php
/**
 * webEdition CMS
 *
 * $Rev: 1a73906214ea $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-07-01 23:44 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
// file
$years = we_shop_shop::getAllOrderYears();

$we_menu_shop = [
	'shop' =>
	[
		'text' => g_l('modules_shop', '[menu][user]'),
		'icon' => 'fa fa-shopping-cart'
	],
	'jahr' => [
		'text' => g_l('modules_shop', '[menu][year]'),
		'parent' => 'shop',
	],
	['parent' => 'shop'], // separator
	['text' => g_l('modules_shop', '[menu][exit]'),
		'parent' => 'shop',
		'cmd' => 'exit_shop',
	],
// edit
	'edit' => ['text' => g_l('modules_shop', '[menu][shop_edit]'),
		'perm' => [we_base_perm::SHOP_EDIT_ORDER],
		'icon' => 'fa fa-cog'
	],
	['text' => g_l('modules_shop', '[menu][shop_pref]') . '&hellip;',
		'parent' => 'edit',
		'cmd' => 'pref_shop',
		'perm' => [we_base_perm::SHOP_EDIT_PREFS],
	],
	['parent' => 'edit'], // separator
	['text' => g_l('modules_shop', '[menu][shop_status]') . '&hellip;',
		'parent' => 'edit',
		'cmd' => 'edit_shop_status',
		'perm' => [we_base_perm::SHOP_EDIT_PREFS],
	],
	['text' => g_l('modules_shop', '[menu][country_vat]') . '&hellip;',
		'parent' => 'edit',
		'cmd' => 'edit_shop_vat_country',
		'perm' => [we_base_perm::SHOP_EDIT_PREFS],
	],
	['text' => g_l('modules_shop', '[menu][edit_categories]') . '&hellip;',
		'parent' => 'edit',
		'cmd' => 'edit_shop_categories',
		'perm' => [we_base_perm::SHOP_EDIT_PREFS],
		'hide' => !we_modules_info::isActive(we_modules_info::CATEGORY)
	],
	['text' => g_l('modules_shop', '[menu][edit_vats]') . '&hellip;',
		'parent' => 'edit',
		'cmd' => 'edit_shop_vats',
		'perm' => [we_base_perm::SHOP_EDIT_PREFS],
	],
	['text' => g_l('modules_shop', '[shipping][shipping_package]') . '&hellip;',
		'parent' => 'edit',
		'cmd' => 'edit_shop_shipping',
		'perm' => [we_base_perm::SHOP_EDIT_PREFS],
	],
	['text' => g_l('modules_shop', '[shipping][payment_provider]') . '&hellip;',
		'parent' => 'edit',
		'cmd' => 'payment_val',
		'perm' => [we_base_perm::SHOP_EDIT_PREFS],
	],
	['parent' => 'edit'], // separator
	['text' => g_l('modules_shop', '[shipping][revenue_view]'),
		'parent' => 'edit',
		'cmd' => 'revenue_view',
		'perm' => [we_base_perm::SHOP_EDIT_PREFS],
	],
	['parent' => 'edit'], // separator
	'order' => ['text' => g_l('modules_shop', '[menu][order]'),
		'parent' => 'edit',
	],
	['text' => g_l('modules_shop', '[menu][add_article_to_order]'),
		'parent' => 'order',
		'cmd' => 'new_article',
		'perm' => [we_base_perm::SHOP_NEW_ARTICLE],
	],
	['text' => g_l('modules_shop', '[menu][delete_order]'),
		'parent' => 'order',
		'cmd' => 'delete_shop',
		'perm' => [we_base_perm::SHOP_DELETE_ARTICLE],
	],
];

foreach($years as $cur){
	$we_menu_shop[] = [
		'text' => $cur,
		'parent' => 'jahr',
		'cmd' => ['year', $cur],
	];
}

return $we_menu_shop;
