<?php

/**
 * webEdition CMS
 *
 * $Rev: 342e215a2edb $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-03-21 11:07 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_editor_info_objectFile extends we_editor_base{

	public function show(){
		$hasWorkflow = we_modules_info::isActive(we_modules_info::WORKFLOW);

		$parts = [
			['headline' => 'ID',
				'html' => ($this->we_doc->ID ?: "-"),
				'icon' => we_html_multiIconBox::PROP_META,
				'noline' => true,
			],
			['headline' => g_l('weEditorInfo', '[content_type]'),
				'html' => g_l('weEditorInfo', '[' . $this->we_doc->ContentType . ']'),
				'space' => we_html_multiIconBox::SPACE_ICON,
				'rightHeadline' => true
			],
			['headline' => g_l('weEditorInfo', '[creation_date]'),
				'html' => date(g_l('weEditorInfo', '[date_format]'), $this->we_doc->CreationDate),
				'noline' => true,
				'icon' => we_html_multiIconBox::INFO_CALENDAR
			],
			['headline' => g_l('modules_users', '[created_by]'),
				'html' => f('SELECT CONCAT(First," ",Second," (",username,")") FROM ' . USER_TABLE . ' WHERE ID=' . $this->we_doc->CreatorID),
				'space' => we_html_multiIconBox::SPACE_ICON,
				'noline' => true,
				'rightHeadline' => true,
				'hide' => empty($this->we_doc->CreatorID)
			],
			['headline' => g_l('weEditorInfo', '[changed_date]'),
				'html' => date(g_l('weEditorInfo', '[date_format]'), $this->we_doc->ModDate),
				'space' => we_html_multiIconBox::SPACE_ICON,
				'noline' => true,
				'rightHeadline' => true
			],
			['headline' => g_l('modules_users', '[changed_by]'),
				'html' => f('SELECT CONCAT(First," ",Second," (",username,")") FROM ' . USER_TABLE . ' WHERE ID=' . $this->we_doc->ModifierID),
				'space' => we_html_multiIconBox::SPACE_ICON,
				'noline' => true,
				'rightHeadline' => true,
				'hide' => empty($this->we_doc->ModifierID)
			],
			['headline' => g_l('weEditorInfo', '[lastLive]'),
				'html' => ($this->we_doc->Published ? date(g_l('weEditorInfo', '[date_format]'), $this->we_doc->Published) : "-"),
				'icon' => we_html_multiIconBox::INFO_CALENDAR,
				'preline' => true
			],
			['headline' => g_l('modules_workflow', '[workflow]'),
				'html' => ($hasWorkflow ? (we_workflow_utility::inWorkflow($this->we_doc->ID, $this->we_doc->Table) ?
				we_workflow_utility::getDocumentStatusInfo($this->we_doc->ID, $this->we_doc->Table) :
				we_workflow_utility::getLogButton($this->we_doc->ID, $this->we_doc->Table)) : ''),
				'rightHeadline' => true,
				'icon' => we_html_multiIconBox::INFO_WORKFLOW,
				'hide' => !$hasWorkflow
			]
		];

		return $this->getPage(we_html_multiIconBox::getHTML('', $parts, true));
	}

}
