<?php

/**
 * webEdition CMS
 *
 * $Rev: 27aac04455e2 $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-08-27 10:09 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_hidden extends we_weTag_tag{

	public static function tag(array $attribs = [], $content = '', $internal = false){

		if(($foo = self::attributeMissing($attribs, "name", __CLASS__))){
			return $foo;
		}

		$name = self::getAttribute("name", $attribs, '', we_base_request::STRING);
		$xml = self::getAttribute('xml', $attribs, XHTML_DEFAULT, we_base_request::BOOL);
		$varType = self::getAttribute('varType', $attribs, we_base_request::STRING, we_base_request::STRING);

		switch(self::getAttribute("type", $attribs, '', we_base_request::STRING)){
			case 'session':
				$value = self::getArrayValue($_SESSION, null, $name);
				break;
			case 'request':
				$value = we_base_util::rmPhp(we_base_request::filterVar(self::getArrayValue($_REQUEST, null, $name), $varType));
				break;
			default:
				$value = self::getArrayValue($GLOBALS, null, $name);
				break;
		}

		return getHtmlTag('input', ['type' => 'hidden', 'name' => $name, 'value' => $value, 'xml' => $xml]);
	}

}

function we_tag_hidden(array $attribs){
	return we_tag_hidden::tag($attribs);
}
