<?php

/**
 * webEdition CMS
 *
 * $Rev: 7c924c6b8352 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-05-26 14:02 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_ifTemplate extends we_weTag_ifTag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		$id = self::getAttribute('id', $attribs, [], we_base_request::INTLISTA);
		$TID = (isset($GLOBALS['we_doc']->TemplateID) ? $GLOBALS['we_doc']->TemplateID : ($GLOBALS['we_doc'] instanceof we_template && isset($GLOBALS['we_doc']->ID) ? $GLOBALS['we_doc']->ID : 0));

		if($TID && $id){
			return in_array($TID, $id);
		}
		$parentid = self::getAttribute('workspaceID', $attribs, self::getAttribute('parentid', $attribs, 0, we_base_request::INT, true), we_base_request::INT);
		if($parentid){
			$curTempPath = (isset($GLOBALS['we_doc']->TemplatePath) ? // in documents
				str_replace(TEMPLATES_PATH, '', $GLOBALS['we_doc']->TemplatePath) :
				// in templates
				$GLOBALS['we_doc']->Path);
			$path = fS('SELECT Path FROM ' . TEMPLATES_TABLE . ' WHERE ID=' . intval($parentid) . ' LIMIT 1');
			return ($path && strpos($curTempPath, $path) === 0);
		}

		$path = strtr(self::getAttribute('path', $attribs, '', we_base_request::FILE), ['.tmpl' => '.php']);
		return (!$path ||
			(isset($GLOBALS['we_doc']->TemplatePath) && preg_match('|^' . TEMPLATES_PATH . strtr(preg_quote($path, '|'), ['\*' => '.*']) . '\$|', $GLOBALS['we_doc']->TemplatePath)));
	}

}

function we_tag_ifTemplate(array $attribs){
	return we_tag_ifTemplate::tag($attribs);
}
