<?php

/**
 * webEdition CMS
 *
 * $Rev$
 * $Author$
 * $Date$
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_ifVotingField extends we_weTag_ifTag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(($foo = self::attributeMissing($attribs, 'match', __CLASS__))){
			echo $foo;
			return false;
		}

		$operator = self::getAttribute('operator', $attribs, '', we_base_request::RAW);
		$match = self::getAttribute('match', $attribs, '', we_base_request::RAW);

		$atts = removeAttribs($attribs, ['match', 'operator']);
		$realvalue = we_tag('votingField', $atts);

		switch($operator){
			default:
			case 'equal':
				return $realvalue == $match;
			case 'less':
				return intval($realvalue) < intval($match);
			case 'less|equal':
				return intval($realvalue) <= intval($match);
			case 'greater':
				return intval($realvalue) > intval($match);
			case 'greater|equal':
				return intval($realvalue) >= intval($match);
			case 'contains':
				return (strpos($realvalue, $match) !== false);
		}
	}

}

function we_tag_ifVotingField(array $attribs){
	return we_tag_ifVotingField::tag($attribs);
}
