<?php

/**
 * webEdition CMS
 *
 * $Rev: cc823e5005ff $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-08-28 18:01 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_listdir extends we_weTag_tag{
	public static $position = ['position' => 0, 'size' => 0];

	public static function parse(array $attribs, $content){
		return '<?php
		' . we_weTag_parser::printTag('listdir', $attribs) . ';
while(' . we_weTag_parser::printTag('listdir', ['_internal' => true]) . '){
	?>' . $content . '<?php
}
unset($GLOBALS[\'we_position\'][\'listdir\']);
we_weTag_tag::post_listview();?>';
	}

	public static function tag(array $attribs = [], $content = '', $internal = false){
		static $files = [];
		if(self::getAttribute('_internal', $attribs, false, we_base_request::BOOL)){
			$pos = self::$position['position'];
			if(!isset($files[$pos])){
				return false;
			}
			$we_locfile = $files[$pos];
			we_tag_listview::$current->field = $we_locfile['Text'];
			we_tag_listview::$current->ID = $we_locfile['ID'];
			we_tag_listview::$current->Path = $we_locfile['Path'];
			self::$position = [
				'position' => $pos + 1,
				'size' => count($files),
				'field' => $we_locfile['Text'],
				'id' => $we_locfile['ID'],
				'path' => $we_locfile['Path']];
			return true;
		}
		$files = [];

		$dirID = self::getAttribute('id', $attribs, $GLOBALS['we_doc']->ParentID, we_base_request::INT);
		$index = self::getAttribute('index', $attribs, ['index.html', 'index.htm', 'index.php', 'default.htm', 'default.html', 'default.php'], we_base_request::STRING_LIST);
		$name = self::getAttribute('field', $attribs, '', we_base_request::STRING);
		$dirfield = self::getAttribute('dirfield', $attribs, $name, we_base_request::STRING);
		$sort = self::getAttribute('order', $attribs, '', we_base_request::STRING);
		$desc = self::getAttribute('desc', $attribs, false, we_base_request::BOOL);
		$searchable = self::getAttribute('searchable', $attribs, false, we_base_request::BOOL);

		$db = new DB_WE();
		$db->query('SELECT f.ID,f.Text,f.IsFolder,f.Path,IF(f.IsFolder,pI.ID,0) AS FolderIndex,' .
			($name || $dirfield ? 'c.Dat AS name,' : '') .
			($sort ? 'sc.Dat' : 'f.Text') . ' AS sort
FROM ' .
			FILE_TABLE . ' f LEFT JOIN ' .
			($name || $dirfield ? CONTENT_TABLE . ' c ON (c.DID=f.ID AND c.nHash=IF(f.IsFolder,x\'' . md5($dirfield) . '\',x\'' . md5($name) . '\')) LEFT JOIN ' : '') .
			($sort ? CONTENT_TABLE . ' sc ON (sc.DID=f.ID AND sc.nHash=x\'' . md5($sort) . '\') LEFT JOIN ' : '') .
			FILE_TABLE . ' pI ON (pI.ParentID=f.ID AND pI.IsFolder=0 AND pI.Text IN ("' . implode('","', $index) . '") AND (pI.Published>0 ' . ($searchable ? 'AND pI.IsSearchable=1' : '') . '))

WHERE ((f.Published>0 ' . ($searchable ? 'AND f.IsSearchable=1' : '') . ') OR (f.IsFolder=1)) AND f.ParentID=' . intval($dirID) . ' GROUP BY f.ID ORDER BY ' . ($sort ? 'sort' : 'f.Text') . ($desc ? ' DESC' : ''));

		while($db->next_record(MYSQLI_ASSOC)){
			$id = intval($db->f('IsFolder') ?
				$db->f('FolderIndex') :
				$db->f('ID'));

			if($id){
				$files[] = ['ID' => $db->f('ID'),
					'Path' => $db->f('Path'),
					'Text' => $db->f('Text'),
					'sort' => $db->f('sort'),
				];
			}
		}
		self::$position = ['position' => 0, 'size' => 0];
		//Fake listview
		self::pre_listview(new stdClass());
		return '';
	}

}

function we_tag_listdir(array $attribs){
	return we_tag_listdir::tag($attribs);
}
