<?php
/**
 * webEdition CMS
 *
 * $Rev: b2e2950d4ecc $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-08-28 18:56 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
we_include_tag_file('we_tag_category');

abstract class we_tag_shopCategory extends we_weTag_tag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		$id = self::getAttribute('id', $attribs, false, we_base_request::INT);
		$showpath = self::getAttribute('showpath', $attribs, false, we_base_request::BOOL);
		$rootdir = self::getAttribute('rootdir', $attribs, '', we_base_request::FILE);
		$field = self::getAttribute('field', $attribs, '', we_base_request::STRING);
		$dosave = self::getAttribute('dosave', $attribs, true, we_base_request::BOOL);

		$ret = '';
		if($GLOBALS['we']['editmode']){
			if(!$id){
				$attribs['fromTag'] = 'shopcategory';
				$attribs['_name_orig'] = we_shop_shop::CATEGORY_FIELD_NAME;
				$attribs['field'] = 'PATH';
				$attribs['showpath'] = true;
				$attribs['firstentry'] = ' ';
				$attribs['shopCatIDs'] = implode(',', we_shop_category::getShopCatFieldsFromDir('ID', true));

				return we_tag_category::tag($attribs);
			}

			if($id && $dosave){
				$ret .= we_html_element::hidden('we_' . $GLOBALS['we_doc']->Name . '_category[' . we_shop_shop::CATEGORY_FIELD_NAME . ']', $id);
			}
		}

		$shopCatId = $GLOBALS['we_doc']->getElement(we_shop_shop::CATEGORY_FIELD_NAME) ?: 0;
		$ret .= we_shop_category::getShopCatFieldByID($shopCatId, $GLOBALS['we_doc']->Category, $field, $showpath, $rootdir, true);

		return $ret;
	}

}

function we_tag_shopCategory(array $attribs){
	return we_tag_shopCategory::tag($attribs);
}
