<?php

/**
 * webEdition CMS
 *
 * $Rev: b2e2950d4ecc $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-08-28 18:56 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_title extends we_weTag_tag{

	public static function parse(array $attribs, $content){
		$attribs['_type'] = 'stop';
		return '<?php ' . we_weTag_parser::printTag('title', ['_type' => 'start']) . ';?>' . $content . '<?= ' . we_weTag_parser::printTag('title', $attribs) . ';?>';
	}

	public static function tag(array $attribs = [], $content = '', $internal = false){
		switch(self::getAttribute('_type', $attribs, '', we_base_request::STRING)){
			case 'start':
				ob_start();
				return '';
			case 'stop':
				$content = ob_get_clean();
		}
		$htmlspecialchars = self::getAttribute('htmlspecialchars', $attribs, false, we_base_request::BOOL);
		$prefix = self::getAttribute('prefix', $attribs, '', we_base_request::RAW_CHECKED);
		$suffix = self::getAttribute('suffix', $attribs, '', we_base_request::RAW_CHECKED);
		$delimiter = self::getAttribute('delimiter', $attribs, '', we_base_request::RAW_CHECKED);

		$content = $GLOBALS['we']['main']['doc']->getElement(we_contents_root::TITLE_FIELD, we_contents_base::ETYPE_TEXT, $content, true);

		if(!empty($GLOBALS['we']['editmode'])){
			//set meta data & exit
			$GLOBALS['meta'][we_contents_root::TITLE_FIELD]['default'] = $content;
			return '';
		}

		$content = ($prefix ? $prefix . ($content ? $delimiter : '') : '') . $content . ($suffix ? ($content ? $delimiter : ($prefix ? $delimiter : '')) . $suffix : '');

		return getHtmlTag('title', removeAttribs($attribs, ['htmlspecialchars', 'prefix', 'suffix', 'delimiter', '_type']), str_replace(['<', '>'], '', ($htmlspecialchars ? oldHtmlspecialchars(strip_tags($content)) : strip_tags($content))), true) . "\n";
	}

}

function we_tag_title(array $attribs, $content = ''){
	return we_tag_title::tag($attribs, $content);
}
