<?php
/**
 * webEdition CMS
 *
 * $Rev: 705b52293e1a $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-07-27 19:48 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
require_once(WE_INCLUDES_PATH . 'we_tag.inc.php');

we_html_tools::protect();

//
//	---> Initalize the document
//

$cmd = we_base_request::_(we_base_request::STRING, 'we_cmd', '', 0);
$we_transaction = we_base_request::_(we_base_request::TRANSACTION, 'we_cmd', $we_transaction, 1);

$identifier = we_base_request::_(we_base_request::STRING, 'we_cmd', false, 2);

$we_doc = new we_objectFile();

$we_dt = $_SESSION['weS']['we_data'][$we_transaction];
$we_doc->we_initSessDat($we_dt);

//
//	---> Setting the Content-Type
//

$charset = $we_doc->getElement('Charset', we_contents_base::ETYPE_TEXT, DEFAULT_CHARSET, true); //	send charset which might be determined in template
//	---> Loading the Stylesheets
$header = '';
if($we_doc->CSS){
	$cssArr = id_to_path(explode(',', $we_doc->CSS), FILE_TABLE, null, true);
	foreach($cssArr as $path){
		$header .= we_html_element::cssLink($path);
	}
}

$jsCmd = new we_base_jsCmd();

switch($cmd){
	case 'object_reload_entry_at_object':
	case 'object_up_meta_at_object':
	case 'object_down_meta_at_object':
	case 'object_insert_meta_at_object':
	case 'object_delete_meta_at_object':
	case 'object_change_objectlink':
	case 'object_remove_image_at_object':
	case 'object_delete_link_at_object':
	case 'object_change_link_at_object':
		$temp = explode('_', $identifier);
		$type = array_shift($temp);
		$name = implode('_', $temp);

		$db = new DB_WE();
		$table = OBJECT_FILES_TABLE;
		switch($cmd){
			case 'object_insert_meta_at_object':
				$we_doc->addMetaToObject($name, we_base_request::_(we_base_request::INT, 'we_cmd', 0, 3));
				break;
			case 'object_delete_meta_at_object':
				$we_doc->removeMetaFromObject($name, we_base_request::_(we_base_request::INT, 'we_cmd', 0, 3));
				break;
			case 'object_down_meta_at_object':
				$we_doc->downMetaAtObject($name, we_base_request::_(we_base_request::INT, 'we_cmd', 0, 3));
				break;
			case 'object_up_meta_at_object':
				$we_doc->upMetaAtObject($name, we_base_request::_(we_base_request::INT, 'we_cmd', 0, 3));
				break;
			case 'object_change_objectlink':
				$we_doc->getLinkedObjects();
				break;
			case 'object_remove_image_at_object':
				$we_doc->remove_image($name);
				break;
			case 'object_delete_link_at_object':
				$we_doc->delElement($name);
				break;
			case 'object_change_link_at_object':
				$we_doc->changeLink($name);
				break;
		}

		$content = we_gui_OrderContainer::wrapField($jsCmd, 'reload', $identifier, '
<div id="' . $identifier . '" class="objectFileElement">
	<div id="f' . $identifier . '" class="default defaultfont">
	' . $we_doc->getFieldHTML($jsCmd, $name, $type, []) . '
	</div>
</div>');

		$we_doc->saveInSession($_SESSION['weS']['we_data'][$we_transaction]);
		break;

	default:
		$content = '';
		break;
}

echo we_html_tools::getHtmlTop('', $charset, 5, $header . we_editor_script::get() . $jsCmd->getCmds(), $content);
